﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CollectionsSort
{
    class Program
    {
        static void Main(string[] args)
        {
            Car car1 = new Car("XX12345", "BMW", 2013);
            Car car2 = new Car("YY12345", "Audi", 2014);
            Car car3 = new Car("ZZ12345", "VW", 2011);

            List<Car> cars = new List<Car>();
            cars.Add(car1);
            cars.Add(car2);
            cars.Add(car3);

            foreach (var car in cars)
            {
                Console.WriteLine(car);
            }

            Console.WriteLine();
            Console.WriteLine("Sort by RegNo:");
            cars.Sort();          
            foreach (var car in cars)
            {
                Console.WriteLine(car);
            }

            Console.WriteLine();
            Console.WriteLine("Sort by Model:");
            cars.Sort(new CarModelComparator());
            foreach (var car in cars)
            {
                Console.WriteLine(car);
            }

            Console.WriteLine();
            Console.WriteLine("Sort by Year:");
            cars.Sort(new CarYearComparator());
            foreach (var car in cars)
            {
                Console.WriteLine(car);
            }

            //Notice: Contains are using the Equal-method, if the Equal-method is not overridden - it returns false! 
            //(since the default Equal-method from class Object uses reference eqvality and not value eqvality). After override 
            //of Equals (and HashCode) Contains return true. 
            Console.WriteLine(cars.Contains(new Car("YY12345", "Audi", 2014)));

            Console.WriteLine(cars.Contains(car1)); //True in both cases - since car1 is a reference to the object in the List 
            


            Dictionary<int,Car> carDictionary = new Dictionary<int, Car>();
            carDictionary.Add(1, car1);
            carDictionary.Add(2, car1);   //Notice: you can have the same object twice in a Dictionary
      //    carDictionary.Add(2, car); //But not with the same key - key must be uniqe.
           
            foreach (var car in carDictionary)
            {
                Console.WriteLine(car.Value);
            }

            Console.WriteLine();
            Console.WriteLine("HashSet");
            HashSet<Car> carHashSet = new HashSet<Car>();
            Console.WriteLine(carHashSet.Add(car1));
            Console.WriteLine(carHashSet.Add(car1));
            Console.WriteLine(carHashSet.Add(car2));
            foreach (var car in carHashSet)
            {
                Console.WriteLine(car); 
            }
        }
    }
}
